pp <- read.table("c:/articles/reasoning/dube/r-scripts/old-data&dube-exp3-binary.dat")
#You will have to change this path to point to the directory in which the above *.dat file
# is located
e<-c(rep(0,24))
NN<-c(rep(0,12))
#Study 1
d<-pp[1:24,2]
#Study 2; naive
#d<-pp[25:48,2]
#Study 2; expert
#d<-pp[49:72,2]
#Study 3
#d<-pp[73:96,2]
#Study 4, naive
#d<-pp[97:120,2]
#Study 4, expert
#d<-pp[121:144,2]
#Study 5
#d<-pp[145:168,2]
#Study 6, naive
#d<-pp[169:192,2]
#Study 6, expert
#d<-pp[193:216,2]
#Study 7
#d<-pp[217:240,2]
#Dube et al., Exp. 3, dichotomized
#d<-pp[241:264,2]

for (i in 1:12) NN[i]<-sum(d[(2*i-1):(2*i)])

#base <- function(dd,NN) {
#temp<-0.0
#x<-dd
#p<-dd
#for (i in 1:24) p[i]<-p[i]/NN[((i+1)/2)]
#for (i in 1:24) temp<-temp-2*x[i]*log(p[i])
#temp
#}

basec <- function(dd,NN) {
temp<-0.0
for (i in 1:12) temp <- temp-2*dbinom(dd[2*i],NN[i],dd[2*i]/NN[i],log=TRUE)
temp
}
 
####UVSDT
g<-function(Q){ 
svb<-Q[9]
svu<-Q[10]
#svb<-1.0
#svu<-1.0
muvb<-Q[1]
muvu<-Q[2]
#muvb<-muvu
#muvb<-0.0
#muvu<-0.0
# Q[3]-Q[8] criterion parameters
#
e[1]<-  NN[1]*(1-pnorm((Q[3]-muvb)/svb))
e[2]<-  NN[1]-e[1]
e[3]<-  NN[2]*(1-pnorm((Q[4]-muvu)/svu))
e[4]<-  NN[2]-e[3]                          
e[5]<-  NN[3]*(1-pnorm(Q[3]))
e[6]<-  NN[3]-e[5]
e[7]<-  NN[4]*(1-pnorm(Q[4]))
e[8]<-  NN[4]-e[7]                         
e[9]<-  NN[5]*(1-pnorm((Q[5]-muvb)/svb))
e[10]<- NN[5]-e[9]
e[11]<- NN[6]*(1-pnorm((Q[6]-muvu)/svu))
e[12]<- NN[6]-e[11]                          
e[13]<- NN[7]*(1-pnorm(Q[5]))
e[14]<- NN[7]-e[13]
e[15]<- NN[8]*(1-pnorm(Q[6]))
e[16]<- NN[8]-e[15]    
e[17]<- NN[9]*(1-pnorm((Q[7]-muvb)/svb))
e[18]<- NN[9]-e[17]
e[19]<- NN[10]*(1-pnorm((Q[8]-muvu)/svu))
e[20]<- NN[10]-e[19]                          
e[21]<- NN[11]*(1-pnorm(Q[7]))
e[22]<- NN[11]-e[21]
e[23]<- NN[12]*(1-pnorm(Q[8]))
e[24]<- NN[12]-e[23]                        
tempsum<-0
for (i in 1:24) {
 if (d[i]==0) t<-0.0
 else t<- 2* d[i]*(log(d[i])-log(e[i]))
 tempsum<-tempsum+t
# print(e)
}
tempsum
}
store <- Inf
for (i in 1:3) {
	Gtest<-nlminb(runif(10),g,control = list(eval.max=1500,iter.max=1500),lower=c(rep(-Inf,8),0,0),upper=c(rep(Inf,10)))
#for Study 7
#Gtest<-nlminb(runif(10),g,control = list(eval.max=1500,iter.max=1500),lower=c(rep(-Inf,8),0,0),upper=c(rep(3,10)))
#
      if (Gtest$objective < store) {store<-Gtest$objective; st<-Gtest}
}
st

svb<-st$par[9]
svu<-st$par[10]
muvb<-st$par[1]
muvu<-st$par[2]
muvb;muvu;svb;svu

#criterion parameters in st$par[3] to st$par[8]

baselog<-basec(d,NN);baselog
AIC <- baselog + st$obj + 2*10
BIC <- baselog + st$obj + 10*log(sum(NN))
AIC; BIC
